diff --git a/apps/swh-scheduler/Dockerfile b/apps/swh-scheduler/Dockerfile
new file mode 100644
index 0000000000000000000000000000000000000000..350827a285f250726910f803b24ee1426a996e56
--- /dev/null
+++ b/apps/swh-scheduler/Dockerfile
@@ -0,0 +1,34 @@
+# Deeply inspired from the Dockerfile of the swh-storage project
+FROM python:3.10-bullseye
+
+RUN apt-get -y update && \
+    apt-get -y upgrade && \
+    apt-get install -y libcmph-dev librdkafka-dev && \
+    apt clean && \
+    addgroup --gid 1000 swh && \
+    useradd --gid 1000 --uid 1000 -m -d /opt/swh swh && \
+    mkdir /etc/swh
+
+USER swh
+WORKDIR /opt/swh
+
+COPY --chown=swh:swh requirements-frozen.txt /opt/swh
+COPY --chown=swh:swh entrypoint.sh /opt/swh
+
+ENV PYTHONPATH=/opt/swh
+ENV PATH=/opt/swh/.local/bin:$PATH
+
+RUN chmod u+x /opt/swh/entrypoint.sh && \
+    /usr/local/bin/python -m pip install --upgrade pip && \
+    pip install --no-cache-dir -r requirements-frozen.txt && \
+    pip install gunicorn
+
+ENV SWH_CONFIG_FILENAME=/etc/swh/config.yml
+ENV PORT 5008
+EXPOSE $PORT
+ENV LOG_LEVEL INFO
+ENV THREADS 2
+ENV WORKERS 2
+ENV TIMEOUT 3600
+
+ENTRYPOINT ["/opt/swh/entrypoint.sh"]
diff --git a/apps/swh-scheduler/entrypoint.sh b/apps/swh-scheduler/entrypoint.sh
new file mode 100644
index 0000000000000000000000000000000000000000..7823376ac873929b29ac6abd0a94183427d57631
--- /dev/null
+++ b/apps/swh-scheduler/entrypoint.sh
@@ -0,0 +1,24 @@
+#!/bin/bash
+
+set -e
+
+case "$1" in
+    "shell")
+        shift
+        if (( $# == 0)); then
+            exec bash -i
+        else
+            "$@"
+        fi
+        ;;
+    *)
+        echo Starting the swh-scheduler API server
+        exec gunicorn --bind 0.0.0.0:5008 \
+            --log-level ${LOG_LEVEL} \
+            --threads ${THREADS} \
+            --workers ${WORKERS} \
+            --reload \
+            --timeout ${TIMEOUT} \
+            --config 'python:swh.core.api.gunicorn_config' \
+            'swh.scheduler.api.server:make_app_from_configfile()'
+esac
diff --git a/apps/swh-scheduler/requirements.txt b/apps/swh-scheduler/requirements.txt
new file mode 100644
index 0000000000000000000000000000000000000000..206155cdd349aadd9bf66cb7b419151e70265390
--- /dev/null
+++ b/apps/swh-scheduler/requirements.txt
@@ -0,0 +1 @@
+swh.scheduler